Merge branch 'maint'
[git/dscho.git] / git-instaweb.sh
blob0843372b57371b62cd68f2818f634209f55d5395
1 #!/bin/sh
3 # Copyright (c) 2006 Eric Wong
6 PERL='@@PERL@@'
7 OPTIONS_KEEPDASHDASH=
8 OPTIONS_SPEC="\
9 git instaweb [options] (--start | --stop | --restart)
11 l,local only bind on 127.0.0.1
12 p,port= the port to bind to
13 d,httpd= the command to launch
14 b,browser= the browser to launch
15 m,module-path= the module path (only needed for apache2)
16 Action
17 stop stop the web server
18 start start the web server
19 restart restart the web server
22 . git-sh-setup
24 fqgitdir="$GIT_DIR"
25 local="$(git config --bool --get instaweb.local)"
26 httpd="$(git config --get instaweb.httpd)"
27 port=$(git config --get instaweb.port)
28 module_path="$(git config --get instaweb.modulepath)"
30 conf="$GIT_DIR/gitweb/httpd.conf"
32 # Defaults:
34 # if installed, it doesn't need further configuration (module_path)
35 test -z "$httpd" && httpd='lighttpd -f'
37 # any untaken local port will do...
38 test -z "$port" && port=1234
40 resolve_full_httpd () {
41 case "$httpd" in
42 *apache2*|*lighttpd*)
43 # ensure that the apache2/lighttpd command ends with "-f"
44 if ! echo "$httpd" | grep -- '-f *$' >/dev/null 2>&1
45 then
46 httpd="$httpd -f"
49 esac
51 httpd_only="$(echo $httpd | cut -f1 -d' ')"
52 if case "$httpd_only" in /*) : ;; *) which $httpd_only >/dev/null;; esac
53 then
54 full_httpd=$httpd
55 else
56 # many httpds are installed in /usr/sbin or /usr/local/sbin
57 # these days and those are not in most users $PATHs
58 # in addition, we may have generated a server script
59 # in $fqgitdir/gitweb.
60 for i in /usr/local/sbin /usr/sbin "$fqgitdir/gitweb"
62 if test -x "$i/$httpd_only"
63 then
64 full_httpd=$i/$httpd
65 return
67 done
69 echo >&2 "$httpd_only not found. Install $httpd_only or use" \
70 "--httpd to specify another httpd daemon."
71 exit 1
75 start_httpd () {
76 # here $httpd should have a meaningful value
77 resolve_full_httpd
79 # don't quote $full_httpd, there can be arguments to it (-f)
80 $full_httpd "$fqgitdir/gitweb/httpd.conf"
81 if test $? != 0; then
82 echo "Could not execute http daemon $httpd."
83 exit 1
87 stop_httpd () {
88 test -f "$fqgitdir/pid" && kill $(cat "$fqgitdir/pid")
91 while test $# != 0
93 case "$1" in
94 --stop|stop)
95 stop_httpd
96 exit 0
98 --start|start)
99 start_httpd
100 exit 0
102 --restart|restart)
103 stop_httpd
104 start_httpd
105 exit 0
107 -l|--local)
108 local=true
110 -d|--httpd)
111 shift
112 httpd="$1"
114 -b|--browser)
115 shift
116 browser="$1"
118 -p|--port)
119 shift
120 port="$1"
122 -m|--module-path)
123 shift
124 module_path="$1"
129 usage
131 esac
132 shift
133 done
135 mkdir -p "$GIT_DIR/gitweb/tmp"
136 GIT_EXEC_PATH="$(git --exec-path)"
137 GIT_DIR="$fqgitdir"
138 export GIT_EXEC_PATH GIT_DIR
141 webrick_conf () {
142 # generate a standalone server script in $fqgitdir/gitweb.
143 cat >"$fqgitdir/gitweb/$httpd.rb" <<EOF
144 require 'webrick'
145 require 'yaml'
146 options = YAML::load_file(ARGV[0])
147 options[:StartCallback] = proc do
148 File.open(options[:PidFile],"w") do |f|
149 f.puts Process.pid
152 options[:ServerType] = WEBrick::Daemon
153 server = WEBrick::HTTPServer.new(options)
154 ['INT', 'TERM'].each do |signal|
155 trap(signal) {server.shutdown}
157 server.start
159 # generate a shell script to invoke the above ruby script,
160 # which assumes _ruby_ is in the user's $PATH. that's _one_
161 # portable way to run ruby, which could be installed anywhere,
162 # really.
163 cat >"$fqgitdir/gitweb/$httpd" <<EOF
164 #!/bin/sh
165 exec ruby "$fqgitdir/gitweb/$httpd.rb" \$*
167 chmod +x "$fqgitdir/gitweb/$httpd"
169 cat >"$conf" <<EOF
170 :Port: $port
171 :DocumentRoot: "$fqgitdir/gitweb"
172 :DirectoryIndex: ["gitweb.cgi"]
173 :PidFile: "$fqgitdir/pid"
175 test "$local" = true && echo ':BindAddress: "127.0.0.1"' >> "$conf"
178 lighttpd_conf () {
179 cat > "$conf" <<EOF
180 server.document-root = "$fqgitdir/gitweb"
181 server.port = $port
182 server.modules = ( "mod_cgi" )
183 server.indexfiles = ( "gitweb.cgi" )
184 server.pid-file = "$fqgitdir/pid"
185 cgi.assign = ( ".cgi" => "" )
186 mimetype.assign = ( ".css" => "text/css" )
188 test x"$local" = xtrue && echo 'server.bind = "127.0.0.1"' >> "$conf"
191 apache2_conf () {
192 test -z "$module_path" && module_path=/usr/lib/apache2/modules
193 mkdir -p "$GIT_DIR/gitweb/logs"
194 bind=
195 test x"$local" = xtrue && bind='127.0.0.1:'
196 echo 'text/css css' > $fqgitdir/mime.types
197 cat > "$conf" <<EOF
198 ServerName "git-instaweb"
199 ServerRoot "$fqgitdir/gitweb"
200 DocumentRoot "$fqgitdir/gitweb"
201 PidFile "$fqgitdir/pid"
202 Listen $bind$port
205 for mod in mime dir; do
206 if test -e $module_path/mod_${mod}.so; then
207 echo "LoadModule ${mod}_module " \
208 "$module_path/mod_${mod}.so" >> "$conf"
210 done
211 cat >> "$conf" <<EOF
212 TypesConfig $fqgitdir/mime.types
213 DirectoryIndex gitweb.cgi
216 # check to see if Dennis Stosberg's mod_perl compatibility patch
217 # (<20060621130708.Gcbc6e5c@leonov.stosberg.net>) has been applied
218 if test -f "$module_path/mod_perl.so" && grep '^our $gitbin' \
219 "$GIT_DIR/gitweb/gitweb.cgi" >/dev/null
220 then
221 # favor mod_perl if available
222 cat >> "$conf" <<EOF
223 LoadModule perl_module $module_path/mod_perl.so
224 PerlPassEnv GIT_DIR
225 PerlPassEnv GIT_EXEC_DIR
226 <Location /gitweb.cgi>
227 SetHandler perl-script
228 PerlResponseHandler ModPerl::Registry
229 PerlOptions +ParseHeaders
230 Options +ExecCGI
231 </Location>
233 else
234 # plain-old CGI
235 resolve_full_httpd
236 list_mods=$(echo "$full_httpd" | sed "s/-f$/-l/")
237 $list_mods | grep 'mod_cgi\.c' >/dev/null 2>&1 || \
238 echo "LoadModule cgi_module $module_path/mod_cgi.so" >> "$conf"
239 cat >> "$conf" <<EOF
240 AddHandler cgi-script .cgi
241 <Location /gitweb.cgi>
242 Options +ExecCGI
243 </Location>
248 script='
249 s#^(my|our) \$projectroot =.*#$1 \$projectroot = "'$(dirname "$fqgitdir")'";#;
250 s#(my|our) \$gitbin =.*#$1 \$gitbin = "'$GIT_EXEC_PATH'";#;
251 s#(my|our) \$projects_list =.*#$1 \$projects_list = \$projectroot;#;
252 s#(my|our) \$git_temp =.*#$1 \$git_temp = "'$fqgitdir/gitweb/tmp'";#;'
254 gitweb_cgi () {
255 cat > "$1.tmp" <<\EOFGITWEB
256 @@GITWEB_CGI@@
257 EOFGITWEB
258 # Use the configured full path to perl to match the generated
259 # scripts' 'hashpling' line
260 "$PERL" -p -e "$script" "$1.tmp" > "$1"
261 chmod +x "$1"
262 rm -f "$1.tmp"
265 gitweb_css () {
266 cat > "$1" <<\EOFGITWEB
267 @@GITWEB_CSS@@
268 EOFGITWEB
271 gitweb_cgi "$GIT_DIR/gitweb/gitweb.cgi"
272 gitweb_css "$GIT_DIR/gitweb/gitweb.css"
274 case "$httpd" in
275 *lighttpd*)
276 lighttpd_conf
278 *apache2*)
279 apache2_conf
281 webrick)
282 webrick_conf
285 echo "Unknown httpd specified: $httpd"
286 exit 1
288 esac
290 start_httpd
291 url=http://127.0.0.1:$port
293 if test -n "$browser"; then
294 git web--browse -b "$browser" $url || echo $url
295 else
296 git web--browse -c "instaweb.browser" $url || echo $url